package cn.com.qmth.examcloud.core.questions.service.temp.vo;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.questions.base.enums.GenPaperType;
import cn.com.qmth.examcloud.core.questions.dao.PaperStructRepo;
import cn.com.qmth.examcloud.core.questions.dao.entity.PaperDetailStruct;
import cn.com.qmth.examcloud.core.questions.dao.entity.PaperDetailUnitStruct;
import cn.com.qmth.examcloud.core.questions.dao.entity.PaperStruct;

/**
 * @author 		weiwenhai
 * @date		2017.9.7
 * @company		qmth
 * @describle	批量跟新线上精确试卷结构工具类
 */

@Service("updatePaperStructService")
public class UpdatePaperStruct {
	
	@Autowired
    PaperStructRepo paperStructRepo;
	
	@Autowired
    MongoTemplate mongoTemplate;

	public void updatePaperStruct(String orgId){
		//根据orgId查询所有精确试卷结构
		Query query = new Query();
        query.addCriteria(Criteria.where("orgId").is(orgId));
        query.addCriteria(Criteria.where("id").nin("BLUEPRINT"));
        long count = this.mongoTemplate.count(query, PaperStruct.class);
        List<PaperStruct> paperStructList = this.mongoTemplate.find(query, PaperStruct.class);
        if(paperStructList!=null && paperStructList.size()>0){
        	for(PaperStruct paperStruct:paperStructList){
        		//1.跟新type
        		if(StringUtils.isBlank(paperStruct.getType())){
        			paperStruct.setType("EXACT");
        		}
        		//2.跟新genPaperType
        		if(paperStruct.getGenPaperType() == null){
        			paperStruct.setGenPaperType(GenPaperType.COMMON);
        		}
        		List<PaperDetailStruct> paperDetailStructs = paperStruct.getPaperDetailStructs();
        		for(PaperDetailStruct paperDetailStruct:paperDetailStructs){
        			//得到以前的小题
        			List<PaperDetailUnitStruct> unitStructs = paperDetailStruct.getPaperDetailUnitStructs();
        			for(PaperDetailUnitStruct unitStruct:unitStructs){
        				unitStruct.setDifficulty("中");
                		unitStruct.setPublicity(true);
                		unitStruct.setPropertyGroup(buildGroup(unitStruct));
        			}
        		}
        	}
        }
        paperStructRepo.save(paperStructList);
	}
	
	/**
     * 构建精确组建筛选条件
     * @param unitStruct
     * @return
     */
    private String buildGroup(PaperDetailUnitStruct unitStruct){
    	return String.valueOf(unitStruct.getPublicity()) + "-" + unitStruct.getDifficulty();
    }
}
